/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ustasoft.config;

import com.ustasoft.component.FrmSettingMenuGrup;
import com.ustasoft.component.GeneralFunction;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import pos.MainForm;

/**
 *
 * @author ustadho
 */
public class DlgMenuGroup extends javax.swing.JDialog {
    GeneralFunction fn=new GeneralFunction();
    private MainForm mainForm;
    /**
     * Creates new form DlgMenuGroup
     */
    public DlgMenuGroup(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        jTable1.getColumn("Menu").setPreferredWidth(150);
    }

    private void udfLoadMenuUserAuth() {
        chkAll.setSelected(false);

        String sQry="select m.kode, m.id, m.menu_description, g.menu_id is not null pilih  \n" +
                    "from m_menu_list m\n" +
                    "left join m_menu_list_grouping g on g.menu_id=m.id and g.group_id='"+cmbGroup.getSelectedItem().toString()+"'\n" +
                    "where module_name='POS'\n" +
                    "order by m.kode ";
        try{
            ResultSet rs=MainForm.conn.createStatement().executeQuery(sQry);
            ((DefaultTableModel)jTable1.getModel()).setNumRows(0);

            while(rs.next()){
                ((DefaultTableModel)jTable1.getModel()).addRow(new Object[]{
                    rs.getString("kode"),
                    rs.getString("menu_description"),
                    rs.getBoolean("pilih"),
                    rs.getInt("id")
                });
            }
            if(jTable1.getRowCount()>0)
                jTable1.setRowSelectionInterval(0, 0);

            jTable1.setModel((DefaultTableModel)fn.autoResizeColWidth(jTable1, (DefaultTableModel)jTable1.getModel()).getModel());
        }catch(SQLException se){
            JOptionPane.showMessageDialog(null, se.getMessage());
        }
    }

    public void setMainForm(MainForm aThis) {
        mainForm=aThis;
    }

    private void udfSave(){
        String sIns="Delete from m_menu_list_grouping where group_id='"+cmbGroup.getSelectedItem().toString()+"'; ";
        try{
            MainForm.conn.setAutoCommit(false);
            for (int i=0; i<jTable1.getRowCount(); i++){
                if((Boolean)jTable1.getValueAt(i, jTable1.getColumnModel().getColumnIndex("Pilih"))){
                sIns+=  "Insert into m_menu_list_grouping(menu_id, group_id) VALUES( " +
                        ""+fn.udfGetInt(jTable1.getValueAt(i, jTable1.getColumnModel().getColumnIndex("ID")).toString())+"," +
                        "'"+cmbGroup.getSelectedItem().toString()+"');";
                }
            }
            
            int iR=MainForm.conn.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_UPDATABLE).executeUpdate(sIns);
            MainForm.conn.setAutoCommit(true);
            
            if (iR>0) JOptionPane.showMessageDialog(this, "Update Successful!");

            mainForm.udfSetUserMenu();

        }catch(SQLException se){
            try {
                MainForm.conn.setAutoCommit(true);
                MainForm.conn.rollback();
                JOptionPane.showMessageDialog(this, se.getMessage());
            } catch (SQLException ex) {
                Logger.getLogger(FrmSettingMenuGrup.class.getName()).log(Level.SEVERE, null, ex);
            }

        }
    }

    private void udfInitForm(){
        try{
            ResultSet rs=MainForm.conn.createStatement().executeQuery("select group_id from m_menu_group order by 1");
            cmbGroup.removeAllItems();
            cmbGroup.addItem("< Semua >");
            while(rs.next()){
                cmbGroup.addItem(rs.getString(1));
            }

            rs.close();
        }catch(SQLException se){
            JOptionPane.showMessageDialog(this, se.getMessage());
        }
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel3 = new javax.swing.JLabel();
        cmbGroup = new javax.swing.JComboBox();
        jSeparator1 = new javax.swing.JSeparator();
        chkAll = new javax.swing.JCheckBox();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Pengelompokan Menu");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel2.setText("Daftar Menu");
        getContentPane().add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 380, 20));

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Kode", "Menu", "Pilih", "ID"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Boolean.class, java.lang.Integer.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, true, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.getTableHeader().setReorderingAllowed(false);
        jScrollPane2.setViewportView(jTable1);

        getContentPane().add(jScrollPane2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 30, 710, 424));

        jLabel3.setText("Group");
        getContentPane().add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(390, 5, 70, 20));

        cmbGroup.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cmbGroup.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cmbGroupItemStateChanged(evt);
            }
        });
        cmbGroup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbGroupActionPerformed(evt);
            }
        });
        getContentPane().add(cmbGroup, new org.netbeans.lib.awtextra.AbsoluteConstraints(470, 5, 250, -1));
        getContentPane().add(jSeparator1, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 474, 240, 10));

        chkAll.setText("Check All");
        chkAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkAllActionPerformed(evt);
            }
        });
        getContentPane().add(chkAll, new org.netbeans.lib.awtextra.AbsoluteConstraints(420, 465, 120, -1));

        jButton1.setText("Update");
        jButton1.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        getContentPane().add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(540, 464, 100, 30));

        jButton2.setText("Close");
        jButton2.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        getContentPane().add(jButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(640, 464, 80, 30));

        setBounds(0, 0, 736, 533);
    }// </editor-fold>//GEN-END:initComponents

    private void cmbGroupItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cmbGroupItemStateChanged
        if(cmbGroup.getSelectedIndex()>=0)
        udfLoadMenuUserAuth();
    }//GEN-LAST:event_cmbGroupItemStateChanged

    private void cmbGroupActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbGroupActionPerformed

    }//GEN-LAST:event_cmbGroupActionPerformed

    private void chkAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkAllActionPerformed
        for(int i=0; i<jTable1.getRowCount(); i++){
            ((DefaultTableModel)jTable1.getModel()).setValueAt(chkAll.isSelected(), i, 2);
        }
    }//GEN-LAST:event_chkAllActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        udfSave();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        this.dispose();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        udfInitForm();
    }//GEN-LAST:event_formWindowOpened

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(DlgMenuGroup.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(DlgMenuGroup.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(DlgMenuGroup.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(DlgMenuGroup.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                DlgMenuGroup dialog = new DlgMenuGroup(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox chkAll;
    private javax.swing.JComboBox cmbGroup;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
